using System.Reflection.Emit;

namespace Micro.Interfaces.SymTab
{
    public interface ISymbol
    {
        SymbolKind Kind { get; }
        string Name { get; }
        IStruct Type { get; }

        /// next Symbol node in this scope
        ISymbol Next { get; }

        /// Const: value;
        int Val { get; }

        /// Field, Arg, Local: order of declaration in scope
        int Adr { get; }

        /// Func: # of arguments
        int NArgs { get; }

        /// Func: # of local variables
        int NLocs { get; }

        /// Func: arguments, then local variables;
        ISymbol Locals { get; }

        /// this field is necessary for the building the assembly
        /// with System.Reflection.Emit
        /// Method: builder for metadata and CIL
        MethodBuilder Meth { get; set; }
        
        bool Equals(object o);
        int GetHashCode();
    }
}